# module ActiveRecord::AttributeMethods::PrimaryKey::ClassMethods

### Constants

ID_ATTRIBUTE_METHODS

### Public Instance Methods

dangerous_attribute_method?(method_name) click to toggle source
Calls superclass method

    # File lib/active_record/attribute_methods/primary_key.rb, line 66
    def dangerous_attribute_method?(method_name)
      super && !ID_ATTRIBUTE_METHODS.include?(method_name)
    end

instance_method_already_implemented?(method_name) click to toggle source
Calls superclass method

    # File lib/active_record/attribute_methods/primary_key.rb, line 62
    def instance_method_already_implemented?(method_name)
      super || primary_key && ID_ATTRIBUTE_METHODS.include?(method_name)
    end

primary_key() click to toggle source

Defines the primary key field – can be overridden in subclasses. Overwriting will negate any effect of the `primary_key_prefix_type` setting, though.

    # File lib/active_record/attribute_methods/primary_key.rb, line 73
    def primary_key
      @primary_key = reset_primary_key unless defined? @primary_key
      @primary_key
    end

primary_key=(value) click to toggle source

Sets the name of the primary key column.

    class Project < ActiveRecord::Base
      self.primary_key = 'sysid'
    end

You can also define the primary_key method yourself:

    class Project < ActiveRecord::Base
      def self.primary_key
        'foo_' + super
      end
    end

    Project.primary_key # => "foo_id"

    # File lib/active_record/attribute_methods/primary_key.rb, line 122
    def primary_key=(value)
      @primary_key        = value && value.to_s
      @quoted_primary_key = nil
      @attributes_builder = nil
    end

quoted_primary_key() click to toggle source

Returns a quoted version of the primary key name, used to construct SQL statements.

    # File lib/active_record/attribute_methods/primary_key.rb, line 80
    def quoted_primary_key
      @quoted_primary_key ||= connection.quote_column_name(primary_key)
    end

### Private Instance Methods

suppress_composite_primary_key(pk) click to toggle source

    # File lib/active_record/attribute_methods/primary_key.rb, line 130
                def suppress_composite_primary_key(pk)
                  return pk unless pk.is_a?(Array)

                  warn "                WARNING: Active Record does not support composite primary key.

                    #{table_name} has composite primary key. Composite primary key is ignored.
    ".strip_heredoc
                end